#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <xc.h>
#include "uart.h"
#include "analog.h"

void initAnalog(void){
    
    // Set pins 3 (RC0), 4 (RC1), 7 (RA2), 8(RA3), 9(RB4) to analog
    ANSELCbits.ANSC0 = 1; 
    ANSELCbits.ANSC1 = 1;
    ANSELAbits.ANSA2 = 1; 
    ANSELAbits.ANSA3 = 1;
    ANSELBbits.ANSB4 = 1; 
    // Set pins 3 (RC0), 4 (RC1), 7 (RA2), 8(RA3), 9(RB4) to input
    TRISCbits.TRISC0 = 1;
    TRISCbits.TRISC1 = 1;
    TRISAbits.TRISA2 = 1;
    TRISAbits.TRISA3 = 1;
    TRISBbits.TRISB4 = 1;
    
    // Configure ADC
    AD1CON1bits.FORM = 0b000;  // integer 16-bit (DOUT = 0000 0000 0000 0000 0000 dddd dddd dddd)
    AD1CON1bits.SSRC = 0b0000; // Clearing the SAMP bit ends sampling and starts conversion
    AD1CON1bits.MODE12 = 1; // operate in 12-bit (not 10-bit mode)
    AD1CON1bits.ASAM = 1; // enable auto-sampling, Sampling begins immediately after last conversion completes; SAMP bit is automatically set
    //Control Register 2 AD1CON2
    AD1CON2bits.VCFG = 0b000; // sets AVDD and AVSS as voltage references
    AD1CON2bits.BUFREGEN = 1; // ADC result buffer is stored in buffer corresponding to Analog pin (RC0 = AN12 = ADC1BUF12))
    //Control Register 3 AD1CON3
    AD1CON3bits.ADRC = 0; // Clock derived from the Peripheral Bus Clock (PBCLK, 1:1 with SYSCLK)
    AD1CON3bits.ADCS = 8;  // ADC clock TAD = 8 peripheral clock TPB The user software must time the setting 
                           // and clearing of the SAMP bit for at least one TAD cycle to ensure that the ADC will detect the SAMP bit state transition.
    
    // Turn input scanning on (if we're scanning, the CH0SA bit is ignored)
    AD1CON2bits.CSCNA = 1; // input scanning enable
    AD1CON5bits.ASEN = 1; // enable auto scan (converts at the end of each ADRC cycle)
    AD1CON2bits.SMPI = 0b0011; // configure to convert every four inputs
    AD1CSSbits.CSS12 = 1; // set AN12 (C0) to be scanned
    AD1CSSbits.CSS13 = 1; // set AN13 (C1) to be scanned)
    AD1CSSbits.CSS5 = 1; // set AN5 (A2) to be scanned
    AD1CSSbits.CSS6 = 1; // set AN6 (A3) to be scanned)
    
    // turn ADC on
    AD1CON1bits.ON = 1;
    
    // start the first sampling cycle
    AD1CON1bits.SAMP = 1;
    
}


