/* 
 * File:   control.h
 * Author: Kelsey
 *
 * Created on April 12, 2021, 1:42 PM
 */

#ifndef CONTROL_H
#define	CONTROL_H
#include<xc.h>

/*TIMER2*/
#define timer2Prescale T2CONbits.TCKPS
#define timer2Interrupt IFS0bits.T2IF
#define enableMultivectorInterrupts INTCONbits.MVEC = 1
#define setTimer2InterruptPriority IPC4bits.T2IP
#define clearTimer2InterruptFlag IFS0bits.T2IF = 0
#define enableTimer2Interrupt IEC0bits.T2IE = 1
#define timer2On T2CONbits.ON = 1

void initTimer2();


/*SWITCHING CONTROL*/
#define batteryOutflowSwitch LATBbits.LATB5
#define batteryInflowSwitch LATBbits.LATB6
#define open 0
#define close 1

void dischargeBatt(void);
void chargeBatt(void);
void openSSR(void);

void initSSR(void);
double convertAnalogReading(double);

#endif	/* CONTROL_H */

